<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="generator" content="pandoc">
  <meta name="author" content="Gabriel Kulp">
  <meta name="dcterms.date" content="2021-10-21">
  <title>How Linux Loads Programs</title>
  <meta name="apple-mobile-web-app-capable" content="yes">
  <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui">
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/reset.css">
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/reveal.css">
  <style>
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    span.underline{text-decoration: underline;}
    div.column{display: inline-block; vertical-align: top; width: 50%;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    ul.task-list{list-style: none;}
    .display.math{display: block; text-align: center; margin: 0.5rem auto;}
  </style>
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/theme/white.css" id="theme">
</head>
<body>
  <div class="reveal">
    <div class="slides">

<section id="title-slide">
  <h1 class="title">How Linux Loads Programs</h1>
  <p class="author">Gabriel Kulp</p>
  <p class="date">October 21, 2021</p>
</section>

<section id="goals" class="slide level1">
<h1>Goals</h1>
<ul>
<li>Make you feel welcome</li>
<li>Starting points to explore</li>
<li>Help CTF people</li>
<li>Learn how <em>your</em> computer works</li>
</ul>
</section>
<section id="overview" class="slide level1">
<h1>Overview</h1>
<ul>
<li>Shell and <code>PATH</code></li>
<li><code>system()</code> and <code>exec()</code></li>
<li><code>fork</code>, <code>execve</code>, and interrupts</li>
<li>Interpreters, ELF, and <code>ld</code></li>
<li>Static and dynamic linking</li>
<li>Virtual memory</li>
<li>Filesystems</li>
<li>Block devices</li>
<li>Device drivers</li>
</ul>
</section>
<section id="this-talk" class="slide level1">
<h1>This talk</h1>
<ol type="1">
<li>The <code>PATH</code> variable</li>
<li>Interpreters, ELF, and <code>ld</code></li>
<li>Libraries and interrupts</li>
<li>Dynamic linking</li>
<li>Filesystems</li>
</ol>
</section>
<section id="topic-1" class="slide level1">
<h1>Topic 1:</h1>
<h2 id="the-path-variable">The <code>PATH</code> variable</h2>
</section>
<section class="slide level1">

<p>this is probably easier with a demo</p>
</section>
<section id="topic-2" class="slide level1">
<h1>Topic 2:</h1>
<h2 id="interpreters-elf-and-ld">Interpreters, ELF, and <code>ld</code></h2>
</section>
<section id="interpreters" class="slide level1">
<h1>Interpreters</h1>
<p>What’s with <code>#!/bin/bash</code>?</p>
<p>Where does the <code>#!</code> get read?</p>
<p>What about putting something else there?</p>
<p>(quick demo)</p>
</section>
<section class="slide level1">

<h2 id="ways-to-execute">Ways to execute</h2>
<ol type="1">
<li>File starts with <code>#!</code></li>
<li><code>/proc/sys/fs/binfmt_misc</code></li>
<li>ELF (starts with 0x7f ELF)</li>
<li>Some legacy stuff</li>
</ol>
</section>
<section class="slide level1">

<p>ELF header starts with “magic”</p>
<pre><code>$ hexdump -C whoami | head

00000000  7f 45 4c 46 02 01 01 00  00 00 00 00 00 00 00 00
00000010  03 00 3e 00 01 00 00 00  f0 18 02 00 00 00 00 00</code></pre>
</section>
<section class="slide level1">

<p><a href="https://en.wikipedia.org/wiki/Executable_and_Linkable_Format">Wikipedia ELF page</a></p>
<pre><code>00000000  7f 45 4c 46 02 01 01 00  00 00 00 00 00 00 00 00
00000010  03 00 3e 00 01 00 00 00  f0 18 02 00 00 00 00 00</code></pre>
<p>Lots of info:</p>
<ul>
<li>ABI: Linux, OpenBSD, or Nintendo Wii?</li>
<li>ISA: x86? ARM? RISC-V? MIPS?</li>
<li>32-bit, 64-bit, 128-bit?</li>
<li>Little-endian? Big-endian?</li>
<li>Dynamic linking required?</li>
</ul>
</section>
<section class="slide level1">

<p>What’s the goal, exactly?</p>
<p>Let’s think about it backwards.</p>
</section>
<section class="slide level1">

<p><img data-src="https://1.bp.blogspot.com/--K44cqPMBLE/U9YysG3by-I/AAAAAAAACC4/GS_Q_vPLU3g/s1600/memlayout.png" style="width:50.0%" /></p>
</section>
<section class="slide level1">

<p>The main show (for us):</p>
<h2 id="sections">sections</h2>
<p>“this part of file goes in this part of memory”</p>
</section>
<section class="slide level1">

<p><img data-src="https://upload.wikimedia.org/wikipedia/commons/7/77/Elf-layout--en.svg" style="width:50.0%" /></p>
</section>
<section class="slide level1">

<p><code>.data</code> and <code>.text</code> are most important.</p>
<p>Lots of others, though:</p>
<ul>
<li><code>.rodata</code></li>
<li><code>.bss</code></li>
<li><code>.comment</code></li>
<li><code>.dynamic</code></li>
</ul>
</section>
<section class="slide level1">

<p>Demo: rand.c</p>
<p>Tools: <code>hexdump</code>, <code>readelf</code></p>
</section>
<section id="topic-3" class="slide level1">
<h1>Topic 3:</h1>
<h2 id="libraries-and-interrupts">Libraries and Interrupts</h2>
</section>
<section class="slide level1">

<h2 id="include-stdio.h"><code>#include &lt;stdio.h&gt;</code></h2>
<p>What does this do?</p>
</section>
<section class="slide level1">

<p><img data-src="https://upload.wikimedia.org/wikipedia/commons/5/5b/Linux_kernel_map.png" /></p>
</section>
<section class="slide level1">

<h2 id="basic-structure">basic structure:</h2>
<ol type="1">
<li>Your program</li>
<li>Libraries (optional)</li>
<li>C library (<em>technically</em> optional)</li>
</ol>
<p><strong>Interrupt 0x80</strong></p>
<ol start="4" type="1">
<li>System call (kernel ABI)</li>
<li>Kernel syscall implementation</li>
</ol>
</section>
<section class="slide level1">

<h2 id="demo">Demo</h2>
<ul>
<li>show <code>ldd</code></li>
<li>show <code>strace</code> and <code>ltrace</code></li>
<li>talk about interrupts/system calls</li>
<li>show <code>~/week3/stack-ovfl-sc-32</code></li>
</ul>
</section>
<section id="topic-4" class="slide level1">
<h1>Topic 4:</h1>
<h2 id="dynamic-linking">Dynamic Linking</h2>
</section>
<section class="slide level1">

<p>Let’s look at <code>rand.c</code> again.</p>
<p><code>srand</code> and <code>rand</code> are define somewhere else!</p>
</section>
<section class="slide level1">

<p>What can you do with this?</p>
<ul>
<li>Functions defined elsewhere</li>
<li>Program doesn’t quite know <code>rand()</code></li>
<li>Load functions from anywhere?</li>
</ul>
</section>
<section class="slide level1">

<p>Demo: our own library!</p>
</section>
<section id="topic-5" class="slide level1">
<h1>Topic 5:</h1>
<h2 id="filesystems">Filesystems</h2>
</section>
<section class="slide level1">

<p><img data-src="https://upload.wikimedia.org/wikipedia/commons/thumb/e/e0/Open_hard-drive.jpg/688px-Open_hard-drive.jpg" /></p>
</section>
<section class="slide level1">

<p><img data-src="https://www.servethehome.com/wp-content/uploads/2020/08/SNV3400-400G.jpg" /></p>
</section>
<section class="slide level1">

<p>What about a really big book?</p>
</section>
<section class="slide level1">

<p><img data-src="https://sarwiki.informatik.hu-berlin.de/images/b/b3/Lfs-layout-classic.png" /></p>
</section>
<section class="slide level1">

<p>Layers (any FS)</p>
<ol type="1">
<li>Applications</li>
<li>Virtual filesystem (metadata)</li>
<li>File organization (mounts, partitions)</li>
<li>Basic filesystem</li>
<li>I/O and drivers</li>
<li>Physical device</li>
</ol>
</section>
<section class="slide level1">

<p>EXT4 block types (simplified):</p>
<ol type="1">
<li>boot sector</li>
<li>super block</li>
<li>inode bitmap</li>
<li>inodes</li>
<li>data</li>
</ol>
</section>
<section class="slide level1">

<p>Demo:</p>
<ul>
<li><code>mount</code> and <code>fdisk</code></li>
<li><code>cp</code>, <code>ln</code>, <code>mkdir</code>, <code>stat</code></li>
</ul>
</section>
<section id="conclusion" class="slide level1">
<h1>Conclusion</h1>
<p>it’s pretty whack.</p>
<p>questions expected.</p>
</section>
    </div>
  </div>

  <script src="https://unpkg.com/reveal.js@^4//dist/reveal.js"></script>

  <!-- reveal.js plugins -->
  <script src="https://unpkg.com/reveal.js@^4//plugin/notes/notes.js"></script>
  <script src="https://unpkg.com/reveal.js@^4//plugin/search/search.js"></script>
  <script src="https://unpkg.com/reveal.js@^4//plugin/zoom/zoom.js"></script>

  <script>

      // Full list of configuration options available at:
      // https://revealjs.com/config/
      Reveal.initialize({
        // Display controls in the bottom right corner
        controls: false,

        // Help the user learn the controls by providing hints, for example by
        // bouncing the down arrow when they first encounter a vertical slide
        controlsTutorial: true,

        // Determines where controls appear, "edges" or "bottom-right"
        controlsLayout: 'bottom-right',

        // Visibility rule for backwards navigation arrows; "faded", "hidden"
        // or "visible"
        controlsBackArrows: 'faded',

        // Display a presentation progress bar
        progress: false,

        // Display the page number of the current slide
        slideNumber: false,

        // 'all', 'print', or 'speaker'
        showSlideNumber: 'all',

        // Add the current slide number to the URL hash so that reloading the
        // page/copying the URL will return you to the same slide
        hash: false,

        // Start with 1 for the hash rather than 0
        hashOneBasedIndex: false,

        // Flags if we should monitor the hash and change slides accordingly
        respondToHashChanges: true,

        // Push each slide change to the browser history
        history: false,

        // Enable keyboard shortcuts for navigation
        keyboard: true,

        // Enable the slide overview mode
        overview: true,

        // Disables the default reveal.js slide layout (scaling and centering)
        // so that you can use custom CSS layout
        disableLayout: false,

        // Vertical centering of slides
        center: true,

        // Enables touch navigation on devices with touch input
        touch: true,

        // Loop the presentation
        loop: false,

        // Change the presentation direction to be RTL
        rtl: false,

        // see https://revealjs.com/vertical-slides/#navigation-mode
        navigationMode: 'default',

        // Randomizes the order of slides each time the presentation loads
        shuffle: false,

        // Turns fragments on and off globally
        fragments: true,

        // Flags whether to include the current fragment in the URL,
        // so that reloading brings you to the same fragment position
        fragmentInURL: true,

        // Flags if the presentation is running in an embedded mode,
        // i.e. contained within a limited portion of the screen
        embedded: false,

        // Flags if we should show a help overlay when the questionmark
        // key is pressed
        help: true,

        // Flags if it should be possible to pause the presentation (blackout)
        pause: true,

        // Flags if speaker notes should be visible to all viewers
        showNotes: false,

        // Global override for autoplaying embedded media (null/true/false)
        autoPlayMedia: null,

        // Global override for preloading lazy-loaded iframes (null/true/false)
        preloadIframes: null,

        // Number of milliseconds between automatically proceeding to the
        // next slide, disabled when set to 0, this value can be overwritten
        // by using a data-autoslide attribute on your slides
        autoSlide: 0,

        // Stop auto-sliding after user input
        autoSlideStoppable: true,

        // Use this method for navigation when auto-sliding
        autoSlideMethod: null,

        // Specify the average time in seconds that you think you will spend
        // presenting each slide. This is used to show a pacing timer in the
        // speaker view
        defaultTiming: null,

        // Enable slide navigation via mouse wheel
        mouseWheel: false,

        // The display mode that will be used to show slides
        display: 'block',

        // Hide cursor if inactive
        hideInactiveCursor: true,

        // Time before the cursor is hidden (in ms)
        hideCursorTime: 5000,

        // Opens links in an iframe preview overlay
        previewLinks: false,

        // Transition style (none/fade/slide/convex/concave/zoom)
        transition: 'concave',

        // Transition speed (default/fast/slow)
        transitionSpeed: 'default',

        // Transition style for full page slide backgrounds
        // (none/fade/slide/convex/concave/zoom)
        backgroundTransition: 'fade',

        // Number of slides away from the current that are visible
        viewDistance: 3,

        // Number of slides away from the current that are visible on mobile
        // devices. It is advisable to set this to a lower number than
        // viewDistance in order to save resources.
        mobileViewDistance: 2,

        // reveal.js plugins
        plugins: [
          RevealNotes,
          RevealSearch,
          RevealZoom
        ]
      });
    </script>
    </body>
</html>
